// Outer Style
const headerGlobalStyleElement = document.createElement("style")
headerGlobalStyleElement.id = "rps-header-global-style";
headerGlobalStyleElement.textContent = {% filter tojson %}{% include 'global.css.jinja' %}{% endfilter %};

// Header Container
const headerContainer = document.createElement("div");
headerContainer.id = "rps-header-container";
headerContainer.classList.add("rps-header-container");
 
// Header Container
const headerbreadcrumbsContainer = document.createElement("div");
headerbreadcrumbsContainer.id = "rps-header-breadcrumbs";
headerbreadcrumbsContainer.classList.add("rps-header-breadcrumbs");

// Shadow DOM (it is bigger on the inside than on the outside :D)
const headerShadowDimension = headerContainer.attachShadow({ mode: "open" });
headerShadowDimension.innerHTML = "<!-- RPS Header: Shadow Dimension (it is bigger on the inside than on the outside :D) -->";

// Content Style
const headerContentStyleElement = document.createElement("style");
headerContentStyleElement.id = "rps-header-content-style";
headerContentStyleElement.textContent = {% filter tojson %}{% include 'header.css.jinja' %}{% endfilter %};
headerShadowDimension.appendChild(headerContentStyleElement);
 
// Content
const headerContentElement = document.createElement("div");
headerContentElement.id = "rps-header-content";
headerContentElement.classList.add("rps-header-content");
headerContentElement.setAttribute("data-bs-theme", "light");
headerContentElement.innerHTML = {% filter tojson %}{% include 'loader.html.jinja' %}{% endfilter %};
headerShadowDimension.appendChild(headerContentElement);
headerShadowDimension.appendChild(headerbreadcrumbsContainer);

 const headerElementPromise = new Promise((resolve, reject) => {
  document.addEventListener('DOMContentLoaded', () => {
    const headerElementFound = document.getElementById("rps-header");
    if (headerElementFound) {
      if (headerElementFound.nodeName !== "HEADER") {
        {# headerElementFound.innerHTML = '<p style="color: red; font-style:italic;">RPS Header: Element with id \'rps-header\' is not a header element</p>'; #}
        {# reject("RPS Header: Element with id 'rps-header' is not a header element"); #}
        console.error("RPS Header: Element with id 'rps-header' is not a header element");
        resolve(headerElementFound);
      } else {
        resolve(headerElementFound);
      }
    } else {
      // add header element when id 'rps-header' is not in DOM
      const headerElementCreated = document.createElement("header");
      headerElementCreated.id = "rps-header";
      headerElementCreated.classList.add("rps-header");
      document.body.prepend(headerElementCreated);
      resolve(headerElementCreated);
    }
  }
)});

headerElementPromise.then((headerElement) => {
  const header = document.getElementById('rps-header');
  header.appendChild(headerGlobalStyleElement);
  header.appendChild(headerContainer);
}).catch((error) => {
  throw new Error(error);
});

function fetchHeaderBreadcrumbs(){
  fetch(`{{ config.header_base_url | default('') }}/breadcrumbs.html?browser_location=${encodeURIComponent(window.location)}`).then((response) => {
    response.text().then((text) => {
      headerbreadcrumbsContainer.innerHTML =  text;
    }).catch((error) => {
      headerbreadcrumbsContainer.innerHTML = '<p style="color: red; font-style:italic;">RPS Header: Error while parsing content</p>';
      throw new Error("RPS Header: Error while parsing content", error);
    });
  }).catch((error) => {
    headerbreadcrumbsContainer.innerHTML = '<p style="color: red; font-style:italic;">RPS Header: Error while fetching content</p>';
    throw new Error("RPS Header: Error while fetching content", error);
  });
}
fetchHeaderBreadcrumbs();


function fetchHeaderContent(){
  fetch(`{{ config.header_base_url | default('') }}/header.html?only_content=true`).then((response) => {
    response.text().then((text) => {
      headerContentElement.innerHTML = text;
    }).catch((error) => {
      headerContentElement.innerHTML = '<p style="color: red; font-style:italic;">RPS Header: Error while parsing content</p>';
      throw new Error("RPS Header: Error while parsing content", error);
    });
  }).catch((error) => {
    headerContentElement.innerHTML = '<p style="color: red; font-style:italic;">RPS Header: Error while fetching content</p>';
    throw new Error("RPS Header: Error while fetching content", error);
  });
}
fetchHeaderContent();




// listen to window.location changes
window.addEventListener('popstate', function(event) {
  fetchHeaderContent();
  fetchHeaderBreadcrumbs();
});


   
